// friendfn.cpp -- Demonstrate global friend functions

//#include <stream.hpp>
#include <iostream.h>

class two;

class one {
    friend void show(one &c1, two &c2);
  private:
    char *s1;
  public:
    one() { s1 = "Testing "; }
};

class two {
    friend void show(one &c1, two &c2);
  private:
    char *s2;
  public:
    two() { s2 = "one, two, three"; }
};

main()
{
  one c1;
  two c2;

  show(c1, c2);
}

void show(one &c1, two &c2)
{
  cout << c1.s1 << c2.s2 << '\n';
}


// Copyright (c) 1990 by Tom Swan. All rights reserved
// Revision 1.00    Date: 11/22/1990   Time: 07:52 am

// Revision 1.01    Date: 07/08/1991   Time: 05:41 pm
// Converted for Borland C++ 2.0

