// thisis.cpp -- Demonstrate assignment to this

//#include <stream.hpp>
#include <iostream.h>

// Following "pragma" turns off the compiler's warning that assigments
// to 'this' are obsolete, which is true. However, the purpose of
// this sample program is to demonstrate the old style method of
// providing custom memory allocations. See overnew.cpp for an
// example of the modern approach--that is, overloading new.

#pragma warn -att

// Following "pragma" turns off the compiler's warning about unused
// variables, which appear in the program for demonstration only

#pragma warn -aus

class aClass {
  private:
    int x;
  public:
    aClass();
};

char buf[512];

main()
{
  cout << "\nAllocating local instance";
  aClass c1;

  cout << "\nAllocating dynamic instance";
  aClass *c2 = new aClass;
}

aClass::aClass()
{
  if (this == 0) {
    cout << "\n Object allocated by new";
    this = (aClass *)&buf;
  } else
    cout << "\n Object allocated without using new";
  x = 1234;
}


// Copyright (c) 1990 by Tom Swan. All rights reserved
// Revision 1.00    Date: 11/24/1990   Time: 09:45 pm

// Revision 1.01    Date: 07/08/1991   Time: 05:41 pm
// Converted for Borland C++ 2.0

